defstar {
 	name {Cell_Router }
	domain { DE }
	author { Dorgham Sisalem}
        copyright { SEE $PTOLEMY_SIMULATIONS/copyright }

	desc {This star simulates a simple router that can accept three
connections in its input and routes these connections to three different
outputs. The routing is done according to the routing table.
	}

	inmulti { name {INPUT }
                type {message }
	        desc {first input }
	}

	output { name {output0 }
                 type {message }
	         desc {first output}
        }

	output { name { output1}
                 type { message}
	         desc { second output }
        }
        output { name { output2}
                 type { message}
                 desc { 2nd output }
        }
        output { name { output3}
                 type { message}
                 desc { 3rd output }
        }
        output { name { output4}
                 type { message}
                 desc { 4th output }
        }
        output { name { output5}
                 type { message}
                 desc { 5th output }
        }
        output { name { output6}
                 type { message}
                 desc { 6th output }
        }
        output { name { output7}
                 type { message}
                 desc { 7th output }
        }
        output { name { output8}
                 type { message}
                 desc { 8th output }
        }
        output { name { output9}
                 type { message}
                 desc { 9th output }
        }

	output { name { general}
                 type { message}
	         desc { general output}
        }

	defstate {
		name { RoutingTable}
		type { intarray}
		desc { routing map: address of directly connected hosts}
	}

	hinclude { "ATMCell.h" ,<math.h>}

	defstate {
		name { fileName }
		type { string }
		default { "<stdout>" }
		desc { Filename for output }
	}
	hinclude { "pt_fstream.h" }
	protected {
		pt_ofstream *p_out;
	}

	protected { 
		  }

//*****************************************************************************/
// initialization: 
//*****************************************************************************/

	setup { 
              }

//*****************************************************************************/
//*****************************************************************************/

	begin  {  
                LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
		}

//****************************************************************************/
// set scheduling priorities
//****************************************************************************/

	constructor { 
                      p_out = 0;
               	    }
        wrapup {
 	        LOG_DEL; delete p_out;
		p_out = 0;
		}
	destructor { LOG_DEL; delete p_out;}

	go {
                pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
		InDEMPHIter inIter(INPUT);
		InDEPort* inPtr;
		while ((inPtr = inIter++) != 0) 
		{
			while (inPtr->dataNew) 
			{
				Envelope theEnvp;
				inPtr->get().getMessage(theEnvp);
				const ATMCell* cellPtr = (const ATMCell*)
						(&theEnvp)->myData();
				const int dest =cellPtr->readDestination();
				if (dest == RoutingTable[0]) 
				    output0.put(completionTime)<<theEnvp;
                                if (dest == RoutingTable[1]) 
                                    output1.put(completionTime)<<theEnvp;
                                if (dest == RoutingTable[2]) 
                                    output2.put(completionTime)<<theEnvp;
                                if (dest == RoutingTable[3]) 
                                    output3.put(completionTime)<<theEnvp;
                                if (dest == RoutingTable[4]) 
                                    output4.put(completionTime)<<theEnvp;
                                if (dest == RoutingTable[5]) 
                                    output5.put(completionTime)<<theEnvp;
                                if (dest == RoutingTable[6]) 
                                    output6.put(completionTime)<<theEnvp;
                                if (dest == RoutingTable[7]) 
                                    output7.put(completionTime)<<theEnvp;
                                if (dest == RoutingTable[8]) 
                                    output8.put(completionTime)<<theEnvp;
                                if (dest == RoutingTable[9]) 
                                    output9.put(completionTime)<<theEnvp;
				if ((dest != RoutingTable[0]) &&
				    (dest != RoutingTable[1]) &&
                                    (dest != RoutingTable[2]) &&
                                    (dest != RoutingTable[3]) &&
                                    (dest != RoutingTable[4]) &&
                                    (dest != RoutingTable[5]) &&
                                    (dest != RoutingTable[6]) &&
                                    (dest != RoutingTable[7]) &&
                                    (dest != RoutingTable[8]) &&
                                    (dest != RoutingTable[9]) )
				     general.put(completionTime)<<theEnvp;
				inPtr->getSimulEvent();
			}
		}	
	   } // end go
} // end defstar

