static const char file_id[] = "DECellsToTCP.pl";
// .cc file generated from DECellsToTCP.pl by ptlang
/*
 * copyright (c) See $PTOLEMY_SIMULATIONS/tcp/copyright
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DECellsToTCP.h"

const char *star_nm_DECellsToTCP = "DECellsToTCP";

const char* DECellsToTCP :: className() const {return star_nm_DECellsToTCP;}

ISA_FUNC(DECellsToTCP,DEStar);

Block* DECellsToTCP :: makeNew() const { LOG_NEW; return new DECellsToTCP;}

DECellsToTCP::DECellsToTCP ()
{
	setDescriptor("This star receives ATMCells and rebuilds the TCPPacket.\n          For misordered cell the sequence number of the TCPPacket \n          is sent to the lostPackets output.");
	addPort(input.setPort("input",this,MESSAGE));
	addPort(output.setPort("output",this,MESSAGE));
	addPort(lostPackets.setPort("lostPackets",this,INT));
	addState(VC.setState("VC",this,"0","VC"));


}

void DECellsToTCP::wrapup() {
# line 50 "DECellsToTCP.pl"
log.flush();
}

void DECellsToTCP::setup() {
# line 45 "DECellsToTCP.pl"
expected= 0;  // expected sequence number
                received= 0; // sequence number of last received cell
                log.open("merge.log");
}

void DECellsToTCP::go() {
# line 52 "DECellsToTCP.pl"
completionTime= arrivalTime;
                outOfSequence= 0;

                // get cells

                Envelope inEnvlp;
                input.get().getMessage(inEnvlp);
                ATMCell *Cell= (ATMCell*) inEnvlp.myData(); 

                TCPP * s= (TCPP *) Cell->cell; // use struct to retrieve header

                received= Cell->readSeq(); 

                if (received != expected )
	        {
                  // some cell has gone lost
                  lostPackets.put(completionTime) << (int)s->Seq;
                  expected= 0;                   // reset counter
                  outOfSequence= 1;
                }
	
                if (received==0)  // first cell of an AudioPacket arrived 
                {
                  expected= 1;
              
                  // how many cells make up this TCPPacket ?

                  numberOfCells= ( s->Size +
                    TCPPACKET_HEADERLENGTH)/48 +
                    ((s->Size + TCPPACKET_HEADERLENGTH)%48>0);
                }
                else              // cell has arrived in order
                  if (!outOfSequence) expected++;
	         

                if (received==numberOfCells-1 && !outOfSequence)

                    // TCPPacket complete
                { 
                   TCPPacket* tcp= new TCPPacket( s->Seq);
	           tcp->setAck(s->Ack);
	           tcp->setWin(s->Win);
	           tcp->setSize(s->Size);
	           tcp->setNum(s->Num);
	           tcp->setVC(VC);
	           tcp->setTimestamp(s->Timestamp);
                   Envelope outEnvlp (*tcp);
                   // output tcp packet
                   output.put(completionTime) << outEnvlp;
                   
                   expected= 0;                   // reset counter
                }
}

// prototype instance for known block list
static DECellsToTCP proto;
static RegisterBlock registerBlock(proto,"CellsToTCP");
