defstar {
 	name { CellsToTCP }
	domain { DE }
	author { Bernd Deffner and Dorgham Sisalem }
	version { %W% %G% }
        copyright {See $PTOLEMY_SIMULATIONS/tcp/copyright
        }
	location {  }
	desc { This star receives ATMCells and rebuilds the TCPPacket.
          For misordered cell the sequence number of the TCPPacket 
          is sent to the lostPackets output. 
	}

	input { 
          name { input }
          type { message }
          desc { arriving cell }
        }

	output { 
          name { output } 
          type { message }
          desc { complete TCPPacket }
        }

        output {
          name { lostPackets} 
          type { int }
          desc { sequence number of defective TCPPacket }
        }

	defstate {
		name { VC }
		type {int }
	        default{0}
	}
	hinclude { "ATMCell.h", "TCPPacket.h", <fstream.h> }

	protected { int outOfSequence;
                    int expected,received;
                    int numberOfCells; 
                    ofstream log;
        }
  
        setup { expected= 0;  // expected sequence number
                received= 0; // sequence number of last received cell
                log.open("merge.log");
              }

        wrapup{ log.flush();}

   	go {    completionTime= arrivalTime;
                outOfSequence= 0;

                // get cells

                Envelope inEnvlp;
                input.get().getMessage(inEnvlp);
                ATMCell *Cell= (ATMCell*) inEnvlp.myData(); 

                TCPP * s= (TCPP *) Cell->cell; // use struct to retrieve header

                received= Cell->readSeq(); 

                if (received != expected )
	        {
                  // some cell has gone lost
                  lostPackets.put(completionTime) << (int)s->Seq;
                  expected= 0;                   // reset counter
                  outOfSequence= 1;
                }
	
                if (received==0)  // first cell of an AudioPacket arrived 
                {
                  expected= 1;
              
                  // how many cells make up this TCPPacket ?

                  numberOfCells= ( s->Size +
                    TCPPACKET_HEADERLENGTH)/48 +
                    ((s->Size + TCPPACKET_HEADERLENGTH)%48>0);
                }
                else              // cell has arrived in order
                  if (!outOfSequence) expected++;
	         

                if (received==numberOfCells-1 && !outOfSequence)

                    // TCPPacket complete
                { 
                   TCPPacket* tcp= new TCPPacket( s->Seq);
	           tcp->setAck(s->Ack);
	           tcp->setWin(s->Win);
	           tcp->setSize(s->Size);
	           tcp->setNum(s->Num);
	           tcp->setVC(VC);
	           tcp->setTimestamp(s->Timestamp);
                   Envelope outEnvlp (*tcp);
                   // output tcp packet
                   output.put(completionTime) << outEnvlp;
                   
                   expected= 0;                   // reset counter
                }
       
	} // end go
} // end defstar
