static const char file_id[] = "DEEPD.pl";
// .cc file generated from DEEPD.pl by ptlang
/*
 * copyright (c) SEE $PTOLEMY_SIMULATIONS/copyright
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEEPD.h"

const char *star_nm_DEEPD = "DEEPD";

const char* DEEPD :: className() const {return star_nm_DEEPD;}

ISA_FUNC(DEEPD,DEStar);

Block* DEEPD :: makeNew() const { LOG_NEW; return new DEEPD;}

DEEPD::DEEPD ()
{
	setDescriptor("This star implements the early packet discard scheme. When \nthe size of the attached queue reaches a certain threshold the next arriving\ncomplete packet is dropped.");
	addPort(in_cell.setPort("in_cell",this,MESSAGE));
	addPort(Size.setPort("Size",this,INT));
	addPort(out_cell.setPort("out_cell",this,MESSAGE));
	addState(Threshold.setState("Threshold",this,"","When to start discarding cells"));
	addState(fileName.setState("fileName",this,"<stdout>","Filename for output"));

# line 70 "DEEPD.pl"
Size.before(in_cell);
                      p_out = 0;
}

void DEEPD::wrapup() {
# line 74 "DEEPD.pl"
LOG_DEL; delete p_out;
		p_out = 0;
}

void DEEPD::begin() {
# line 61 "DEEPD.pl"
LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
}

DEEPD::~DEEPD() {
# line 77 "DEEPD.pl"
LOG_DEL; delete p_out;
}

void DEEPD::setup() {
# line 52 "DEEPD.pl"
DISCARD=0;
	        i=0;
		THRESHOLD=0;
}

void DEEPD::go() {
# line 80 "DEEPD.pl"
pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
		Envelope Envp;

//**************************************************************************/
//        updata the queue size
//**************************************************************************/
		if(Size.dataNew)
		{
			Size.dataNew=FALSE;
			size=Size%0;
			if(size>Threshold)
				THRESHOLD=1;
			else
		           THRESHOLD=0;
			
		}
//**************************************************************************/
//        recieve new cells
//**************************************************************************/
		if(in_cell.dataNew)
		{
	  	    in_cell.get().getMessage(Envp);
				const ATMCell* cellPtr=(const ATMCell *)
		    			Envp.myData();
		    long int seq=cellPtr->readSeq();
		    int current_dest=cellPtr->readDestination();
		    int current_VC=cellPtr->readVC();
             TCPP * s= (TCPP *) cellPtr->cell; // use struct to retrieve header
		    if(THRESHOLD==1)
		    {
			if(DISCARD==0)
			{
				if(seq>0) //deliver the rest of the current packet
				{
					out_cell.put(completionTime)<<Envp;
					return;
				}
OUTPUT<<" DISCARD "<<s->Seq<<" seq "<<seq<<" Size "<<size<<" Destination "<<cellPtr->readDestination()<<" VC "<<cellPtr->readVC()<<" at "<<completionTime<<"\n"; 
	                        Destination=current_dest;
				VC=current_VC;
				DISCARD=1;
			}
			return;	
		    }
// If the queue is no longer congested but a part of a packet was already
//discarded, drop the rest of the packer.
		    if((DISCARD==1)&&(VC==current_VC)&&(Destination==current_dest))
		    {
		        if(seq>0)
		           return;
			DISCARD=0;
	            }
		    out_cell.put(completionTime)<<Envp;
		}
}

// prototype instance for known block list
static DEEPD proto;
static RegisterBlock registerBlock(proto,"EPD");
