 defstar {
 	name {EPD }
	domain { DE }
	author { Dorgham Sisalem}
        copyright { SEE $PTOLEMY_SIMULATIONS/copyright }

	desc { This star implements the early packet discard scheme. When 
the size of the attached queue reaches a certain threshold the next arriving
complete packet is dropped. 
	}

	input { name { in_cell}
                type { message}
	}
	input { name { Size}
                type { int}
	}

	output { name {out_cell }
                 type { message}
        }


 	hinclude { "ATMCell.h", "TCPPacket.h",<math.h>}

	defstate {
		name { Threshold }
		type { int }
		desc {  When to start discarding cells}
	}
	defstate {
		name { fileName }
		type { string }
		default { "<stdout>" }
		desc { Filename for output }
	}
	hinclude { "pt_fstream.h" }
	protected {
		pt_ofstream *p_out;
	}

	protected { 
			int DISCARD,THRESHOLD,Destination,VC;
			int size;
			int i;
		  }

//*****************************************************************************/
// initialization: 
//*****************************************************************************/

	setup { DISCARD=0;
	        i=0;
		THRESHOLD=0;
              }

//*****************************************************************************/
//*****************************************************************************/

	begin  {  
                LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
		}

//****************************************************************************/
// set scheduling priorities
//****************************************************************************/

	constructor { 
		      Size.before(in_cell);
                      p_out = 0;
               	    }
        wrapup {
	        LOG_DEL; delete p_out;
		p_out = 0;
		}
	destructor { LOG_DEL; delete p_out;}

	go {
                pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
		Envelope Envp;

//**************************************************************************/
//        updata the queue size
//**************************************************************************/
		if(Size.dataNew)
		{
			Size.dataNew=FALSE;
			size=Size%0;
			if(size>Threshold)
				THRESHOLD=1;
			else
		           THRESHOLD=0;
			
		}
//**************************************************************************/
//        recieve new cells
//**************************************************************************/
		if(in_cell.dataNew)
		{
	  	    in_cell.get().getMessage(Envp);
				const ATMCell* cellPtr=(const ATMCell *)
		    			Envp.myData();
		    long int seq=cellPtr->readSeq();
		    int current_dest=cellPtr->readDestination();
		    int current_VC=cellPtr->readVC();
             TCPP * s= (TCPP *) cellPtr->cell; // use struct to retrieve header
		    if(THRESHOLD==1)
		    {
			if(DISCARD==0)
			{
				if(seq>0) //deliver the rest of the current packet
				{
					out_cell.put(completionTime)<<Envp;
					return;
				}
OUTPUT<<" DISCARD "<<s->Seq<<" seq "<<seq<<" Size "<<size<<" Destination "<<cellPtr->readDestination()<<" VC "<<cellPtr->readVC()<<" at "<<completionTime<<"\n"; 
	                        Destination=current_dest;
				VC=current_VC;
				DISCARD=1;
			}
			return;	
		    }
// If the queue is no longer congested but a part of a packet was already
//discarded, drop the rest of the packer.
		    if((DISCARD==1)&&(VC==current_VC)&&(Destination==current_dest))
		    {
		        if(seq>0)
		           return;
			DISCARD=0;
	            }
		    out_cell.put(completionTime)<<Envp;
		}
	   } // end go
} // end defstar
