static const char file_id[] = "DEMakeTCPPacket.pl";
// .cc file generated from DEMakeTCPPacket.pl by ptlang
/*
 * copyright (c) See $PTOLEMY_SIMULATIONS/TCP/copyright
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEMakeTCPPacket.h"

const char *star_nm_DEMakeTCPPacket = "DEMakeTCPPacket";

const char* DEMakeTCPPacket :: className() const {return star_nm_DEMakeTCPPacket;}

ISA_FUNC(DEMakeTCPPacket,DEStar);

Block* DEMakeTCPPacket :: makeNew() const { LOG_NEW; return new DEMakeTCPPacket;}

DEMakeTCPPacket::DEMakeTCPPacket ()
{
	setDescriptor("This star generates an empty TCP-Packet at firing.\n                The Packet used for simulation is a data structure consisting \n                of the  information fields source, destination, Acknowledgment\n                Size, sequence byte number and sequence number.\n                As an input it gets the size of the packet.");
	addPort(input.setPort("input",this,FLOAT));
	addPort(output.setPort("output",this,MESSAGE));
	addState(start_value.setState("start_value",this,"0","Start value for the sequence counter."));
	addState(source.setState("source",this,"0","number of source node."));
	addState(destination.setState("destination",this,"0","number of destination node."));
	addState(VC.setState("VC",this,"0","number of destination node."));
	addState(mode.setState("mode",this,"0","0=ECN off, 1=ECN on."));


}

void DEMakeTCPPacket::setup() {
# line 56 "DEMakeTCPPacket.pl"
delayType= FALSE;
		count = start_value;
		num=0;
}

void DEMakeTCPPacket::go() {
# line 62 "DEMakeTCPPacket.pl"
completionTime= arrivalTime;
		int Size=input%0; //read the desired packet size
	        num+=Size;
		LOG_NEW;
                TCPPacket* Packet = new TCPPacket( count ); //create the packet
int ack=(count+1)*Size;
                // set source and destination,size and byte sequence
                Packet->setSource(source);
                Packet->setVC(VC);
                Packet->setDestination(destination);
       		Packet->setSize(Size);
       		Packet->setAck(ack);
		Packet->setNum(num);
		Packet->setWin(20000);
		if(mode)
	              Packet->setECN_ON(1);
		else
	              Packet->setECN_ON(0);
	        Packet->setECN(0);

		// send the envelope
		Envelope envlp( *Packet );
		output.put( completionTime ) << envlp;
		count++;
}

// prototype instance for known block list
static DEMakeTCPPacket proto;
static RegisterBlock registerBlock(proto,"MakeTCPPacket");
