defstar {
 	name { MakeTCPPacket }
	domain { DE }
	author { Bernd Deffner & DorghamSisalem }
        copyright { See $PTOLEMY_SIMULATIONS/TCP/copyright }

	location { $PTOLEMY_SIMULATIONS/TCP }
	desc { This star generates an empty TCP-Packet at firing.
                The Packet used for simulation is a data structure consisting 
                of the  information fields source, destination, Acknowledgment
                Size, sequence byte number and sequence number.
                As an input it gets the size of the packet.
	}


	input { name { input } type { float } }
	output { name { output } type { message } }

	defstate {
		name { start_value }
		type { int  }
		default { 0 }
		desc { Start value for the sequence counter.}
	}
	defstate {
		name { source }
		type { int }
		default { 0}
		desc { number of source node.}
	}
	defstate {
		name { destination }
		type { int  }
		default { 0 }
		desc { number of destination node.}
	}
	defstate {
		name { VC }
		type { int  }
		default { 0 }
		desc { number of destination node.}
	}
	defstate {
		name { mode }
		type { int  }
		default { 0 }
		desc {0=ECN off, 1=ECN on.}
	}

	hinclude { "TCPPacket.h" }

	protected { long count;
	            long num;}

	setup {
	        delayType= FALSE;
		count = start_value;
		num=0;
	}

	go {
                completionTime= arrivalTime;
		int Size=input%0; //read the desired packet size
	        num+=Size;
		LOG_NEW;
                TCPPacket* Packet = new TCPPacket( count ); //create the packet
int ack=(count+1)*Size;
                // set source and destination,size and byte sequence
                Packet->setSource(source);
                Packet->setVC(VC);
                Packet->setDestination(destination);
       		Packet->setSize(Size);
       		Packet->setAck(ack);
		Packet->setNum(num);
		Packet->setWin(20000);
		if(mode)
	              Packet->setECN_ON(1);
		else
	              Packet->setECN_ON(0);
	        Packet->setECN(0);

		// send the envelope
		Envelope envlp( *Packet );
		output.put( completionTime ) << envlp;
		count++;
	} // end go
} // end defstar









