 defstar {
 	name {PPD }
	domain { DE }
	author { Dorgham Sisalem}
        copyright { SEE $PTOLEMY_SIMULATIONS/copyright }

	desc { This star implements partial packet discard scheme. Whenever
the attched queue reaches a certain threshold it starts dropping the arriving
cells. With the partial packet discard all cells belonging to the current
passing packet are dropped. Thus cells that will be dropped at the source 
anyway are directly dropped at the switch.

Note: We have not actually used this star in further simulations. Therefore,
the implementation is too simple and is only applicable to 2 VCs.
	}

	input { name { in_cell}
                type { message}
	}
	input { name { discard}
                type { message}
	}

	output { name {out_cell }
                 type { message}
        }


	hinclude { "ATMCell.h" ,<math.h>}

	defstate {
		name { VCTable}
		type { intarray}
		desc { The VCs using PPD}
	}
	defstate {
		name { fileName }
		type { string }
		default { "<stdout>" }
		desc { Filename for output }
	}
	hinclude { "pt_fstream.h" }
	protected {
		pt_ofstream *p_out;
	}

	protected { 
			long int Seq1,Seq2;
			int Dest1,Dest2;
			int size;
		  }

//*****************************************************************************/
// initialization: 
//*****************************************************************************/

	setup { 
		Seq1=-1;
		Seq2=-1;
		Dest1=VCTable[0];
		Dest2=VCTable[1];
              }

//*****************************************************************************/
//*****************************************************************************/

	begin  {  
                LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
		}

//****************************************************************************/
// set scheduling priorities
//****************************************************************************/

	constructor { 
                      p_out = 0;
               	    }
        wrapup {
	        LOG_DEL; delete p_out;
		p_out = 0;
		}
	destructor { LOG_DEL; delete p_out;}

	go {
                pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
		Envelope Envp;
//********************************************************************/
//  alarm the PPD star that a cell was dropped 
//********************************************************************/
		if(discard.dataNew)
		{
	  		discard.get().getMessage(Envp);
			const ATMCell* cellPtr=(const ATMCell *)
		    		Envp.myData();
		 	int dest=cellPtr->readDestination();
// mark the VC from which a cell was dropped
			if(dest==Dest1)
				Seq1=cellPtr->readSeq();
			if(dest==Dest2)
				Seq2=cellPtr->readSeq();
	
		}
//******************************************************************/
// receive new cells
//******************************************************************/
		if(in_cell.dataNew)
		{
	  	    in_cell.get().getMessage(Envp);
		    if((Seq1!=-1)||(Seq2!=-1))
		    {
			const ATMCell* cellPtr=(const ATMCell *)
		    		Envp.myData();
		 	int dest=cellPtr->readDestination();
			long int seq=cellPtr->readSeq();
			if((dest==Dest1)&&(Seq1!=-1))
				if(seq==0)
				{
					Seq1=-1;
					out_cell.put(completionTime)<<Envp;
				}
			if((dest==Dest2)&&(Seq2!=-1))
				if(seq==0)
				{
					Seq2=-1;
					out_cell.put(completionTime)<<Envp;
				}
		    }	
		    else
			out_cell.put(completionTime)<<Envp;

		}
	   } // end go
} // end defstar
