static const char file_id[] = "DERED.pl";
// .cc file generated from DERED.pl by ptlang
/*
 * copyright (c) SEE $PTOLEMY_SIMULATIONS/copyright
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DERED.h"
#include <ACG.h>

const char *star_nm_DERED = "DERED";

const char* DERED :: className() const {return star_nm_DERED;}

ISA_FUNC(DERED,DEStar);

Block* DERED :: makeNew() const { LOG_NEW; return new DERED;}

# line 67 "DERED.pl"
extern ACG* gen;

DERED::DERED ()
{
	setDescriptor("This star simulates the random early packet drop scheme. The \navarage queue length is calculated as an exponential weigthed moving\navaerage. Is the avergae between a Min and a Max threshold then packets\nare dropped with a probability b. Is the averge larger than the maximum \nthreshold then all arriving packets must be dropped.");
	addPort(size.setPort("size",this,INT));
	addPort(in.setPort("in",this,MESSAGE));
	addPort(out.setPort("out",this,MESSAGE));
	addPort(overflow.setPort("overflow",this,MESSAGE));
	addState(Wg.setState("Wg",this,"0.002","queue weight"));
	addState(Min.setState("Min",this,"10","min threshold"));
	addState(Max.setState("Max",this,"100","max threshold"));
	addState(MaxP.setState("MaxP",this,"0.02","max threshold"));
	addState(alpha.setState("alpha",this,"0.8","reduction factor"));
	addState(fileName.setState("fileName",this,"<stdout>","Filename for output"));

# line 114 "DERED.pl"
p_out = 0;
		      random = NULL;
}

void DERED::wrapup() {
# line 119 "DERED.pl"
LOG_DEL; delete p_out;
		p_out = 0;
}

void DERED::begin() {
# line 103 "DERED.pl"
LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
		if(random) delete random;
		random=new Uniform(0,1,gen);
}

DERED::~DERED() {
# line 122 "DERED.pl"
LOG_DEL; delete p_out;
}

void DERED::setup() {
# line 92 "DERED.pl"
av=0;
	        count=-1;
		min=max=0;
		C1=MaxP/(Max-Min);
		C2=(MaxP*Min)/(Max-Min);
}

void DERED::go() {
# line 125 "DERED.pl"
pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
//**********************************************************
//  Update the queue length average 
//**********************************************************
		if(size.dataNew)
		{
		   	Size=size.get();
		  	float temp=(float)Size-av; 
		   av=av+(float)((float)Wg*(float)temp);
		}
//*********************************************************
//  receive new data
//*********************************************************
		if(in.dataNew)
		{
                        Envelope Envp;
                        in.get().getMessage(Envp);
               		TCPPacket * packetPtr=(TCPPacket *)
                    			Envp.myData();
		if((Min<=av)&&(Max>av))// average between Min and Max
			{
// OUTPUT<<" AVERAGE "<<av<<" Size "<<Size<<" Min "<<Min<<" R/Pb "<<R/Pb<<" cou//nt"<<count<<" at "<<completionTime<<"\n";
                                count++;
				if(count==0)
					R=(*random)();
			        if(!packetPtr->readECN_ON())
			           Pb=(float)alpha*((float)(C1*av)-C2);
				else
				   Pb=(C1*av)-C2;
	                        if((count>0)&&(count>=(R/Pb)))
				{
//OUTPUT<<" Mark DEST "<<packetPtr->readDestination()<<" VC "<<packetPtr->readV//C()<<" SEQ "<<packetPtr->readSeq()<<"\n";
					count=0;
	                                overflow.put(completionTime)<<Envp;
					if(!packetPtr->readECN_ON())
					   return;
					else
                                        { 
                                          TCPPacket* last_Packet = new TCPPacket( count ); //create the packet
					  last_Packet->setDestination(packetPtr->readDestination());
					  last_Packet->setSource(packetPtr->readSource());
					  last_Packet->setVC(packetPtr->readVC());
					  last_Packet->setSize(packetPtr->readSize());
					  last_Packet->setWin(packetPtr->readWin());
					  last_Packet->setNum(packetPtr->readNum()); 
					  last_Packet->setSeq(packetPtr->readSeq());
					  last_Packet->setAck(packetPtr->readAck());
					  last_Packet->setTimestamp(packetPtr->readTimestamp());
					  last_Packet->setECN(1);
					  Envelope outEnvp( *last_Packet);
					  out.put(completionTime)<<outEnvp;
					  return;
					 }
				           
				}
			        Envelope envp(*packetPtr);
	                        out.put(completionTime)<<envp;
			}
			else
			{
				 count=-1;
				if(Max<=av)
				{
//OUTPUT<<" AVERAGE @ "<<" MAX "<<Max<<av<<" at "<<completionTime<<"\n";
			                count=-1;		
	                                overflow.put(completionTime)<<Envp;
					if(!packetPtr->readECN_ON())
					   return;
					else
                                        { 
// OUTPUT<<" AVERAGE "<<av<<" Size "<<Size<<" Max "<<max<<" R/Pb "<<R/Pb<<" cou//nt"<<count<<" at "<<completionTime<<"\n";
//OUTPUT<<" Severe DEST "<<packetPtr->readDestination()<<" VC "<<packetPtr->rea//dVC()<<" SEQ "<<packetPtr->readSeq()<<"\n";
                                          TCPPacket* last_Packet = new TCPPacket( count ); //create the packet
					  last_Packet->setDestination(packetPtr->readDestination());
					  last_Packet->setSource(packetPtr->readSource());
					  last_Packet->setVC(packetPtr->readVC());
					  last_Packet->setSize(packetPtr->readSize());
					  last_Packet->setWin(packetPtr->readWin());
					  last_Packet->setSeq(packetPtr->readSeq());
					  last_Packet->setAck(packetPtr->readAck());
					  last_Packet->setNum(packetPtr->readNum());
					  last_Packet->setTimestamp(packetPtr->readTimestamp());
					  last_Packet->setECN(1);
					  Envelope outEnvp( *last_Packet);
					  out.put(completionTime)<<outEnvp;
					  return;
					 }
                                       
				}
			        Envelope envp(*packetPtr);
	                        out.put(completionTime)<<envp;
			}

		}
}

// prototype instance for known block list
static DERED proto;
static RegisterBlock registerBlock(proto,"RED");
