static const char file_id[] = "DEReceiverWin.pl";
// .cc file generated from DEReceiverWin.pl by ptlang
/*
 * copyright (c) SEE $PTOLEMY_SIMULATIONS/TCP/copyright
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEReceiverWin.h"
#include "DataStruct.h"
#include "TCPPacket.h"

const char *star_nm_DEReceiverWin = "DEReceiverWin";

const char* DEReceiverWin :: className() const {return star_nm_DEReceiverWin;}

ISA_FUNC(DEReceiverWin,DEStar);

Block* DEReceiverWin :: makeNew() const { LOG_NEW; return new DEReceiverWin;}

DEReceiverWin::DEReceiverWin ()
{
	setDescriptor("This star simulates the buffer of the application.\n                 It is assumed that the packets always have a constant size\n	         -MSS-. The buffer only receives the sequence number from the\n	         TCP receiver. When the application is ready for a new packet \n                 the size of the window is changed bu MSS\n	         If there is any interest in variable packet sizes\n	         then the receiver must be modified to send real packets.");
	addPort(demand.setPort("demand",this,INT));
	addPort(inData.setPort("inData",this,ANYTYPE));
	addPort(outData.setPort("outData",this,ANYTYPE));
	outData.inheritTypeFrom(inData);
	addPort(size.setPort("size",this,INT));
	addPort(overflow.setPort("overflow",this,ANYTYPE));
	overflow.inheritTypeFrom(inData);
	addState(capacity.setState("capacity",this,"-1","Maximum size of the queue. If <0, capacity is infinite."));
	addState(MSS.setState("MSS",this,"","Maximum segment size"));

# line 58 "DEReceiverWin.pl"
// Indicate to the scheduler that size outputs are triggered
		// demand inputs.
		// simultaneous inData events should be available in the
		// same firing with demand events
         	   demand.before(inData);
}

DEReceiverWin::~DEReceiverWin() {
# line 178 "DEReceiverWin.pl"
zapQueue();
}

void DEReceiverWin::setup() {
# line 65 "DEReceiverWin.pl"
infinite = (int(capacity) < 0);
		control=1;
		Q_Size=0;
		zapQueue();
}

void DEReceiverWin::go() {
# line 133 "DEReceiverWin.pl"
completionTime = arrivalTime;

//****************************************************************************
// The application finished consuming a packet an can take another one
//****************************************************************************

	    if (demand.dataNew)
	    {
	      demand.dataNew= FALSE;
       	      if(Qsize())
	      {
		dequeue();
		Q_Size-=MSS;  //update the buffer size
		outData.put(completionTime)<<Q_Size;
		control=0; // application is busy
	      }
	      else
	        control=1; //application is free
	      size.put(completionTime)<<Q_Size; // update the window size
	    }

//*************************************************************************
// If there is new inData, store it if the application is busy
//*************************************************************************

	    if (inData.dataNew)
	    {
	      inData.dataNew=FALSE;
	      if(!Qsize()&&control)
	      {
		outData.put(completionTime) =inData%0;
	        control=0;
	      }
	      else
	      {
		enqueue();
	        Q_Size+=MSS;

	      }
	      size.put(completionTime)<<Q_Size;
	    }
}


void DEReceiverWin::enqueue ()
{
# line 83 "DEReceiverWin.pl"
if (infinite || Qsize() < int(capacity)) {
			queue.put(inData.get().clone());
		    } else {
			// Data is lost
			overflow.put(completionTime) = inData.get();
		    }
}


Pointer DEReceiverWin::dequeue ()
{
# line 97 "DEReceiverWin.pl"
return queue.get();
}


void DEReceiverWin::handleOverflow ()
{
# line 106 "DEReceiverWin.pl"
// Nothing to do
}


int DEReceiverWin::Qsize ()
{
# line 115 "DEReceiverWin.pl"
return queue.length();
}


void DEReceiverWin::zapQueue ()
{
# line 121 "DEReceiverWin.pl"
while (Qsize() > 0) {
				Particle* pp = (Particle*) queue.get();
				pp->die();
			}
			queue.initialize();
}


// prototype instance for known block list
static DEReceiverWin proto;
static RegisterBlock registerBlock(proto,"ReceiverWin");
