static const char file_id[] = "DESlidingWin.pl";
// .cc file generated from DESlidingWin.pl by ptlang
/*
 * copyright (c) SEE $PTOLEMY_SIMULATIONS/TCP/copyright
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DESlidingWin.h"
#include "DataStruct.h"
#include "TCPPacket.h"

const char *star_nm_DESlidingWin = "DESlidingWin";

const char* DESlidingWin :: className() const {return star_nm_DESlidingWin;}

ISA_FUNC(DESlidingWin,DERepeatStar);

Block* DESlidingWin :: makeNew() const { LOG_NEW; return new DESlidingWin;}

DESlidingWin::DESlidingWin ()
{
	setDescriptor("This star receives the input Packets and sends them to the TCP source\n        if this is possible -i.e. the transmission window is not full yet.\n        Otherwise it buffers the Packets and waits till the source sends\n        a notification, that the window has moved and it is possible to send\n        data. In this case it sends the allowed number of bytes.");
	addPort(refire.setPort("refire",this,FLOAT));
	addPort(demand.setPort("demand",this,INT));
	addPort(inData.setPort("inData",this,ANYTYPE));
	addPort(restart.setPort("restart",this,FLOAT));
	addPort(outData.setPort("outData",this,ANYTYPE));
	outData.inheritTypeFrom(inData);
	addPort(size.setPort("size",this,INT));
	addPort(overflow.setPort("overflow",this,ANYTYPE));
	overflow.inheritTypeFrom(inData);
	addState(capacity.setState("capacity",this,"-1","Maximum size of the queue. If <0, capacity is infinite."));
	addState(MSS.setState("MSS",this,"1","Maximum segment size"));
	addState(Rate.setState("Rate",this,"1","the sending rate of the source"));
	addState(fileName.setState("fileName",this,"<stdout>","Filename for output"));

# line 180 "DESlidingWin.pl"
p_out=NULL;		
	             delayType = TRUE;
}

void DESlidingWin::wrapup() {
# line 176 "DESlidingWin.pl"
LOG_DEL; delete p_out;
		p_out = 0;
}

DESlidingWin::~DESlidingWin() {
# line 266 "DESlidingWin.pl"
zapQueue();
}

void DESlidingWin::setup() {
# line 165 "DESlidingWin.pl"
infinite = (int(capacity) < 0);
		control=MSS;
		Completion_Time=-1;
		Size=MSS;
		zapQueue();
                LOG_DEL; delete p_out;p_out=NULL;
		LOG_NEW; p_out = new pt_ofstream(fileName);
		//DERepeatStar::setup();
}

void DESlidingWin::go() {
# line 184 "DESlidingWin.pl"
pt_ofstream& OUTPUT = *p_out;
	    completionTime = arrivalTime;

//**************************************************************************
//           update the allowed number of byte to be sent
//**************************************************************************

	    if (demand.dataNew)
	    {
	      demand.dataNew= FALSE;
              control=demand%0;    // update the allowed number of 
	  				  // packets to be sent.
              float tmp=completionTime-Completion_Time-Rate+1;
//OUTPUT<<" TMP "<<tmp;
	      tmp=(float)100000000.0*tmp;
//OUTPUT<<" TMP1 "<<tmp;
	      tmp=tmp-(float)100000000.0;
//OUTPUT<<" TMP2 "<<tmp<<" at "<<completionTime<<"\n";
	    if(tmp>10)
	    {
//OUTPUT<<" refire  at "<<completionTime<<"\n";
                  //restart.put(completionTime)<<0;   //schedule the next send
	          refire.dataNew=TRUE;
            }

	    }


//**************************************************************************
// If there is new inData, store it if the window is full
//**************************************************************************

	    if (inData.dataNew)
	    {
	      inData.dataNew=FALSE;
	      if(Qsize())
	      {
	        enqueue();
		return;
	      }
	      if((Size<=control)&&
	            (completionTime>Completion_Time+Rate))
	      {
//OUTPUT<<" NEW RESTART "<<"\n";
	        Envelope Envp;
	        inData.get().getMessage(Envp);
		outData.put(completionTime) <<Envp;
	        refire.dataNew=TRUE;
                //restart.put(completionTime)<<0;   //schedule the next send
	        const TCPPacket* Packet=(const TCPPacket *)Envp.myData();
		Size+=Packet->readSize();
	        Completion_Time=completionTime;
	      }
	      else
		enqueue();
	      size.put(completionTime)<<Qsize();
	    }
//************************************************************************
//   send a new packet
//************************************************************************

	    if(refire.dataNew)
	    {
	      refire.dataNew=FALSE;
     	      if((Size<=control)&&Qsize())
	      {
		Particle* pp =(Particle *)  dequeue();
		Envelope Envp;
		pp->getMessage(Envp);
		const TCPPacket* Packet=(const TCPPacket *)Envp.myData();
		Size+=Packet->readSize();
//OUTPUT<<" OUT Size "<<control<<" Rate "<<Rate<<" at "<<completionTime<<" \n";
		outData.put(completionTime)<<Envp;
                restart.put(completionTime)<<0;//schedule the next send
		pp->die();
	        Completion_Time=completionTime;
	      }
	    }
}


void DESlidingWin::enqueue ()
{
# line 104 "DESlidingWin.pl"
if (infinite || Qsize() < int(capacity)) {
			queue.put(inData.get().clone());
		    } else {
			// Data is lost
			overflow.put(completionTime) = inData.get();
		    }
}


Pointer DESlidingWin::dequeue ()
{
# line 118 "DESlidingWin.pl"
return queue.get();
}


void DESlidingWin::handleOverflow ()
{
# line 127 "DESlidingWin.pl"
// Nothing to do
}


int DESlidingWin::Qsize ()
{
# line 136 "DESlidingWin.pl"
return queue.length();
}


void DESlidingWin::zapQueue ()
{
# line 142 "DESlidingWin.pl"
while (Qsize() > 0) {
				Particle* pp = (Particle*) queue.get();
				pp->die();
			}
			queue.initialize();
}


// prototype instance for known block list
static DESlidingWin proto;
static RegisterBlock registerBlock(proto,"SlidingWin");
