defstar {
 	name { TCPToATM }
	domain { DE }
	author { Bernd Deffner and Dorgham Sisalem }
	version { %W% %G% }
        copyright {see $PTOLEMY_SIMULATIONS/tcp/copyright
        }
	location {  }
	desc { This star receives an TCPPacket and outputs the appropriate
          number of ATMCells. The header of the TCPpacket is stored in the
          payload of the ATMCells. The cells receive sequence numbers.
          limitation: the header has to be less than 48 bytes long
	}

      	defstate {
		name {cellSpacing}
		type {float}
		default {0.001}
                desc {time distance between successive cells}
	}

	input { 
          name { input }
          type { message }
          desc { incoming TCPPacket }
        }

	output { 
           name { output } 
           type { message } 
           desc { outgoing cells }
        }

     	hinclude { "ATMCell.h", "TCPPacket.h" }

	go {  
                // get TCPPacket

                Envelope inEnvlp;
                input.get().getMessage(inEnvlp);
                TCPPacket *tcp= (TCPPacket*) inEnvlp.myData();
             
                // calculate number of cells (tcp header + tcp payload)

                int no_cells= (tcp->readSize() +
                   TCPPACKET_HEADERLENGTH)/48 +
                  ((tcp->readSize()+ TCPPACKET_HEADERLENGTH)%48>0);
                completionTime= arrivalTime;

                // create the necessary amount of cells

                for(int i=0; i<no_cells; i++ )
		{
		  LOG_NEW; 
                  ATMCell* Cell = new ATMCell(i);

                  // set source and destination

                  Cell->setSource( tcp->readSource() );
                  Cell->setDestination( tcp->readDestination() );
                  Cell->setVC( tcp->readVC() );

                  // the sequence number will be used to check if all cells
                  // of an TCPPacket have arrived

                  Cell->setSeq( i );         

                  // pack tcp header data via struct TCPP into cell payload

                  TCPP *s= (TCPP *) Cell->cell; 
  
                  s->Seq= tcp->readSeq();
                  s->Ack= tcp->readAck();
                  s->Win= tcp->readWin();
                  s->Size= tcp->readSize();
                  s->Num= tcp->readNum();
		  s->Timestamp=tcp->readTimestamp();
                 
   		  Envelope envlp( *Cell );

                  // and put it on the road ...

		  output.put( completionTime ) << envlp;
                  completionTime+= cellSpacing;
                }
	} // end go
} // end defstar






