static const char file_id[] = "DETCPToCells.pl";
// .cc file generated from DETCPToCells.pl by ptlang
/*
 * copyright (c) see $PTOLEMY_SIMULATIONS/tcp/copyright
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DETCPToCells.h"

const char *star_nm_DETCPToCells = "DETCPToCells";

const char* DETCPToCells :: className() const {return star_nm_DETCPToCells;}

ISA_FUNC(DETCPToCells,DEStar);

Block* DETCPToCells :: makeNew() const { LOG_NEW; return new DETCPToCells;}

DETCPToCells::DETCPToCells ()
{
	setDescriptor("This star receives a TCPPacket and outputs the appropriate\n          number of ATMCells. The header of the TCPpacket is stored in the\n          payload of the ATMCells. The cells receive sequence numbers.\n          limitation: the header has to be less than 48 bytes long");
	addState(cellSpacing.setState("cellSpacing",this,"0.001","time distance between successive cells"));
	addPort(input.setPort("input",this,MESSAGE));
	addPort(output.setPort("output",this,MESSAGE));


}

void DETCPToCells::go() {
# line 37 "DETCPToCells.pl"
// get TCPPacket

                Envelope inEnvlp;
                input.get().getMessage(inEnvlp);
                TCPPacket *tcp= (TCPPacket*) inEnvlp.myData();
             
                // calculate number of cells (tcp header + tcp payload)

                int no_cells= (tcp->readSize() +
                   TCPPACKET_HEADERLENGTH)/48 +
                  ((tcp->readSize()+ TCPPACKET_HEADERLENGTH)%48>0);
                completionTime= arrivalTime;

                // create the necessary amount of cells

                for(int i=0; i<no_cells; i++ )
		{
		  LOG_NEW; 
                  ATMCell* Cell = new ATMCell(i);

                  // set source and destination

                  Cell->setSource( tcp->readSource() );
                  Cell->setDestination( tcp->readDestination() );
                  Cell->setVC( tcp->readVC() );
		  Cell->setRM(0);
		  Cell->setCI(0);
		  Cell->setEFCI(0);

                  // the sequence number will be used to check if all cells
                  // of an TCPPacket have arrived

                  Cell->setSeq(i);         

                  // pack tcp header data via struct TCPP into cell payload

                  TCPP *s= (TCPP *) Cell->cell; 
  
                  s->Seq= tcp->readSeq();
                  s->Ack= tcp->readAck();
                  s->Win= tcp->readWin();
                  s->Size= tcp->readSize();
                  s->Num= tcp->readNum();
		  s->Timestamp=tcp->readTimestamp();
                 
   		  Envelope envlp( *Cell );

                  // and put it on the road ...

		  output.put( completionTime ) << envlp;
                  completionTime+= cellSpacing;
                }
}

// prototype instance for known block list
static DETCPToCells proto;
static RegisterBlock registerBlock(proto,"TCPToCells");
