.EQ
delim off
.EN
.\" documentation file generated from DETCP_ECN_S.pl by ptlang
.\" SEE $PTOLEMY_SIMULATIONS/tcp/copyright
.NA "TCP_ECN_S"
.SD
This star is a TCP source that is based on the 4.3Tahoe BSD TCP
        implementation and fulfills the following requirements:
        Sliding window mechanism: It only sends if the receiver has enough
                 space. Otherwise it waits until the receiver has freed some
                 buffer and reopened the transmission window.
        Timeout: If an acknowledgment for a specific packet has not arrived
                 after some time, it is resent.
        Round trip time estimation: Using the Karn's algorithm.
        Slow start: For the beginning of the transmission and after a timeout.
        Congestion avoidance: A slow increase of the window size of 1/cwnd
        Fast retransmission: After receiving 3 duplicate acks the source 
                             retransmits the lost packet. 
        Explicit Congestion Notification:Using a bit in the IP header congestion
                             in intermediate switches is indicated.
.SE
.DM DE DEStar
.AL "Dorgham Sisalem"
.IH
.NE
\fIack\fR (message): Acknowledgment packet
.NE
\fIinput\fR (message): new data packets
.NE
\fItimer\fR (message)
.PE
.OH
.NE
\fIdemand\fR (int): get demand number of bytes from the WindowBuf
.NE
\fIoutput\fR (message): send data packets
.NE
\fItimeout\fR (int): last calculated round trip time
.PE
.SH
.NE
\fIWin_Size\fR (IntState): maximum transmission window.
.DF "10"
.NE
\fIMDF\fR (FloatState): multiple decrease factor.
.DF "0.875"
.NE
\fIMSS\fR (IntState): Maximum Segment Size
.DF "1"
.NE
\fIinit_time\fR (FloatState): initial value for RTT
.DF "1"
.NE
\fIRate\fR (FloatState): the sending rate of the source
.DF "1"
.NE
\fIGrain\fR (FloatState): the number of clock ticks in a second
.DF "2"
.NE
\fIdebug\fR (IntState): 0 output debug infos
.DF "0"
.NE
\fIfileName\fR (StringState): Filename for output
.DF "<stdout>"
.ET
.EQ
delim $$
.EN
.ES
