.EQ
delim off
.EN
.\" documentation file generated from DETCP_Rec.pl by ptlang
.NA "TCP_Rec"
.SD
This star simulates a TCP receiver that fulfills the following
        requirements:
        Sliding window: Using  acknowledgment packets, the receiver informs
                the source of the allowed number of bytes that can be sent
	        before the sender buffer gets full.
        Update packets: After sending an acknowledgment with the window size 
                smaller than the maximum segment size (MSS) an update packet 
                is sent when there is new buffer space available.
        silly window: If the window size gets too small -smaller than MSS-
	        an update packet is only sent after freeing enough buffer space
	        - here, it was set to half the original window size.
        Duplicate acks: If a packet is lost the receiver sends for each new 
                received packet an Ack for the last correctly received packet.
                All out of order packets get buffered until the missing packet is
	        received. Only then can these packets get also acknowledged.
        Delayed acks: Ack packets are sent after an ack timer goes off or every
                other packet.

        In this model it is assumed that all packets have the same length
        -MSS-. Based on this the receiver only informs the application when a
        packet is received. If there is any interest in using variable packet
        sizes, the actual received packet must be sent to the application.
.SE
.DM DE DEStar
.AL "Dorgahm Sisalem"
.IH
.NE
\fIinput\fR (message): new data
.NE
\fIAck_Fin\fR (int): ack timer went off
.NE
\fISize\fR (int): size of available buffer
.PE
.OH
.NE
\fIcontrol\fR (message): send Ack
.NE
\fIapplication\fR (int): send a packet to the application
.NE
\fIAck_Start\fR (int): start the ack timer
.PE
.SH
.NE
\fIWindow_Size\fR (IntState): maximum transmission window.
.DF "10"
.NE
\fIfileName\fR (StringState)
.DF ""
.NE
\fIMSS\fR (IntState): Maximum Segment Size
.DF "1"
.NE
\fIAck_Time\fR (IntState): Start value for the acknowledgment timer.
.DF "1"
.NE
\fIdebug\fR (IntState)
.DF "0"
.ET
.EQ
delim $$
.EN
.ES
