static const char file_id[] = "DETCP_Router.pl";
// .cc file generated from DETCP_Router.pl by ptlang
/*
 * copyright (c) SEE $PTOLEMY_SIMULATIONS/copyright
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "DETCP_Router.h"

const char *star_nm_DETCP_Router = "DETCP_Router";

const char* DETCP_Router :: className() const {return star_nm_DETCP_Router;}

ISA_FUNC(DETCP_Router,DEStar);

Block* DETCP_Router :: makeNew() const { LOG_NEW; return new DETCP_Router;}

DETCP_Router::DETCP_Router ()
{
	setDescriptor("This star simulates a simple router that can accept three\nconnections in its input and routes these connections to three different\noutputs. The routing is done according to the routing table.");
	addPort(INPUT.setPort("INPUT",this,MESSAGE));
	addPort(output0.setPort("output0",this,MESSAGE));
	addPort(output1.setPort("output1",this,MESSAGE));
	addPort(general.setPort("general",this,MESSAGE));
	addState(RoutingTable.setState("RoutingTable",this,"","routing map: address of directly connected hosts"));
	addState(fileName.setState("fileName",this,"<stdout>","Filename for output"));
	addState(Mode.setState("Mode",this,"1","1=VP routing else VC routing"));

# line 80 "DETCP_Router.pl"
p_out = 0;
}

void DETCP_Router::wrapup() {
# line 83 "DETCP_Router.pl"
LOG_DEL; delete p_out;
		p_out = 0;
}

void DETCP_Router::begin() {
# line 71 "DETCP_Router.pl"
LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(fileName);
}

DETCP_Router::~DETCP_Router() {
# line 86 "DETCP_Router.pl"
LOG_DEL; delete p_out;
}

void DETCP_Router::setup() {
# line 65 "DETCP_Router.pl"
}

void DETCP_Router::go() {
# line 89 "DETCP_Router.pl"
pt_ofstream& OUTPUT = *p_out;
                completionTime= arrivalTime;
		InDEMPHIter inIter(INPUT);
		InDEPort* inPtr;
		while ((inPtr = inIter++) != 0) 
		{
			while (inPtr->dataNew) 
			{
				Envelope theEnvp;
				inPtr->get().getMessage(theEnvp);
				const TCPPacket* cellPtr = (const TCPPacket*)
						(&theEnvp)->myData();
			        int dest;
				if(Mode==1)
				   dest =cellPtr->readDestination();
				else
				   dest =cellPtr->readVC();
//OUTPUT<<"  DEST "<<dest;
				if(dest==RoutingTable[0]) 
				{
					output0.put(completionTime)<<theEnvp;
				}
				else
				{
					if(dest==RoutingTable[1])
					{
					  output1.put(completionTime)<<theEnvp;
					}
					else
					{
				          general.put(completionTime)<<theEnvp;
					}
				}
				inPtr->getSimulEvent();
			}
		}
}

// prototype instance for known block list
static DETCP_Router proto;
static RegisterBlock registerBlock(proto,"TCP_Router");
