defstar {
 	name { rateMeasure}
	domain { DE }
	author { Dorgham Sisalem}
        copyright { SEE $PTOLEMY_SIMULATIONS/TCP/copyright }

	desc { This star calculates the rate of the incoming data
	}

	input { name { input } type { anytype} }
	output { name { output } type { float} }
	input { name { Timer} type { float} }

	defstate {
		name { logfile}
		type { string}
		desc { }
	}
	defstate {
		name { debug}
		type {int}
		desc { }
	}

	hinclude { "pt_fstream.h" }
	protected {
		pt_ofstream *p_out;
	}

	protected { long count;
		    long sum;
		  }

        setup { delayType= FALSE;
		count=0;
		sum=0;

              }
	begin  {  
                LOG_DEL; delete p_out;
		LOG_NEW; p_out = new pt_ofstream(logfile);
		}
	  constructor{ Timer.before(input);
	               Timer.triggers(output);
		       input.triggers();
		       p_out = 0;

		       }
        wrapup {
	        LOG_DEL; delete p_out;
		p_out = 0;
		}
	destructor { LOG_DEL; delete p_out;}


	go {
                completionTime=arrivalTime;
                pt_ofstream& OUTPUT = *p_out;
		if(Timer.dataNew) // the end of a measurement period
	        {
	           Timer.dataNew=FALSE;
		   output.put(completionTime)<<(float)sum;
if(debug)
OUTPUT<<completionTime<<"\t"<<sum<<"\n";
		   sum=0;
		 }

	         if(input.dataNew)
	         {
	            input.dataNew=FALSE;
		    sum++;  //update the number of packets
		 }

	} // end go
} // end defstar









